/*-------------------------------------------------
   Enter two vectors and calculate the dot product
   using a function.
  -------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*---------------------------------
  define dot product function
  ---------------------------------*/
float dp(int n, float *a, float *b){
  int i;
  float d;
  d = 0.0;
  for(i=0; i<n; i++){
    d += a[i]*b[i];
  }
  return d;
}

/*--------------------------
  main
  --------------------------*/
int main(){
  int i, n;
  float c;
  float *a, *b;

  /*-------------------------------------------
     enter length of vectors
    -------------------------------------------*/
  printf("Enter length of vectors: ");
  scanf("%d", &n);

  /*-------------------------------------------
     use malloc to dynamically allocate the
     two vectors now that we know their length
    -------------------------------------------*/
  a = (float *) malloc(n*sizeof(float));
  b = (float *) malloc(n*sizeof(float));

  /*----------------------------------------
     enter two vectors
    ----------------------------------------*/
  printf("Enter components of first  vector: ");
  for(i=0; i<n; i++){
    scanf("%f", &a[i]);
  }

  printf("Enter components of second vector: ");
  for(i=0; i<n; i++){
    scanf("%f", &b[i]);
  }

  /*----------------------------------------
     calculate dot product
    ----------------------------------------*/
  c = dp(n,a,b);

  /*----------------------------------------
     print warning if magnitude of
     result is less than 1.0e-6
    ----------------------------------------*/
  if(fabsf(c) < 1.0e-6){
    printf("----------------------------------------\n");
    printf("Warning: dot product is less than 1.0e-6\n");
    printf("----------------------------------------\n");
  }

  /*----------------------------------------
     print result
    ----------------------------------------*/
  printf("Dot product = %f\n", c);

}
