#include <stdio.h>
#include <stdlib.h>
#include "dp.h"
#define INFILE "inputfile"
int main(int argc, char *argv[]) {
  int i, veclen;
  int maxlen;
  int ret;
  float *v1, *v2, d;
  FILE *fd;
  if (argc != 2) {
    printf("Usage: %s maximum_vector_length\n", argv[0]);
    exit(1);
  }
  maxlen = atoi(argv[1]);
  fd = fopen(INFILE, "r");
  if (fd == NULL) {
    fprintf(stderr, "Error opening %s\n", INFILE);
    exit(1);
  }
  ret = fscanf(fd, "%d", &veclen);
  if (ret == EOF) {
    fprintf(stderr, "Error reading from %s\n", INFILE);
    exit(1);
  }
  if (veclen > maxlen) {
    printf("Error: vector length (%d) greater than max allowed (%d).\n", veclen, maxlen);
    exit(1);
  }
  v1 = malloc(veclen*sizeof(float));
  v2 = malloc(veclen*sizeof(float));
  for(i=0;i<veclen;i++) {
    ret = fscanf(fd, "%f", v1+i);
    if (ret == EOF) {
      fprintf(stderr, "Error reading from %s\n", INFILE);
      exit(1);
    }
  }
  for(i=0;i<veclen;i++) {
    ret = fscanf(fd, "%f", v2+i);
    if (ret == EOF) {
      fprintf(stderr, "Error reading from %s\n", INFILE);
      exit(1);
    }
  }
  fclose(fd);
  d = dp(veclen, v1, v2);
  printf("Dot product = %7.2f\n", d);
}
